Index: squid/src/disk.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/disk.c,v
retrieving revision 1.4.20.1
retrieving revision 1.4.20.1.2.1
diff -u -r1.4.20.1 -r1.4.20.1.2.1
--- squid/src/disk.c	17 Dec 2000 14:09:08 -0000	1.4.20.1
+++ squid/src/disk.c	17 Dec 2000 14:36:23 -0000	1.4.20.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: disk.c,v 1.4.20.1 2000/12/17 14:09:08 hno Exp $
+ * $Id: disk.c,v 1.4.20.1.2.1 2000/12/17 14:36:23 hno Exp $
  *
  * DEBUG: section 6     Disk I/O Routines
  * AUTHOR: Harvest Derived
@@ -71,7 +71,7 @@
 	    xstrerror());
 	fd = DISK_ERROR;
     } else {
-	debug(6, 5) ("file_open: FD %d\n", fd);
+	debug(91, 9) ("file_open: FD %d (%s)\n", fd, path);
 	commSetCloseOnExec(fd);
 	fd_open(fd, FD_FILE, path);
     }
@@ -192,7 +192,7 @@
     errno = 0;
     if (fdd->write_q->file_offset != -1)
 	lseek(fd, fdd->write_q->file_offset, SEEK_SET);
-    len = write(fd,
+    len = comm_write_wrapper(fd,
 	fdd->write_q->buf + fdd->write_q->buf_offset,
 	fdd->write_q->len - fdd->write_q->buf_offset);
     debug(6, 3) ("diskHandleWrite: FD %d len = %d\n", fd, len);
@@ -233,17 +233,8 @@
 		}
 	    } while ((q = fdd->write_q));
 	}
-	else
-	  {
-	    CLEAR_CAN_WRITE( fd );
-	  }
 	len = 0;
     }
-    else
-      {
-	CLEAR_CAN_WRITE_IF_FULL( fdd->write_q->len - fdd->write_q->buf_offset,
-				 len, fd );
-      }
     if (q != NULL) {
 	/* q might become NULL from write failure above */
 	q->buf_offset += len;
Index: squid/src/enums.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/enums.h,v
retrieving revision 1.6.4.1.2.1
retrieving revision 1.6.4.1.2.1.4.1
diff -u -r1.6.4.1.2.1 -r1.6.4.1.2.1.4.1
--- squid/src/enums.h	17 Dec 2000 13:55:39 -0000	1.6.4.1.2.1
+++ squid/src/enums.h	17 Dec 2000 14:36:24 -0000	1.6.4.1.2.1.4.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: enums.h,v 1.6.4.1.2.1 2000/12/17 13:55:39 hno Exp $
+ * $Id: enums.h,v 1.6.4.1.2.1.4.1 2000/12/17 14:36:24 hno Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -705,3 +705,15 @@
     CBDATA_storeIOState,
     CBDATA_FIRST_CUSTOM_TYPE
 } cbdata_type;
+
+typedef enum {
+  SYSCALLCB_CONTINUE,
+  SYSCALLCB_ABORT
+} syscallcb_result;
+
+typedef enum {
+  SYSCALL_READ = 0,
+  SYSCALL_WRITE,
+  SYSCALL_MAX
+} syscall_type;
+
Index: squid/src/fd.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fd.c,v
retrieving revision 1.4.10.1
retrieving revision 1.4.10.1.2.1
diff -u -r1.4.10.1 -r1.4.10.1.2.1
--- squid/src/fd.c	17 Dec 2000 14:09:08 -0000	1.4.10.1
+++ squid/src/fd.c	17 Dec 2000 14:36:24 -0000	1.4.10.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: fd.c,v 1.4.10.1 2000/12/17 14:09:08 hno Exp $
+ * $Id: fd.c,v 1.4.10.1.2.1 2000/12/17 14:36:24 hno Exp $
  *
  * DEBUG: section 51    Filedescriptor Functions
  * AUTHOR: Duane Wessels
@@ -88,6 +88,9 @@
     commUpdateWriteBits(fd, NULL);
     memset(F, '\0', sizeof(fde));
     F->timeout = 0;
+    F->swap_dir = -1;
+    CLEAR_CAN_READ( fd );
+    CLEAR_CAN_WRITE( fd );
 }
 
 void
@@ -108,6 +111,7 @@
     if (desc)
 	xstrncpy(F->desc, desc, FD_DESC_SZ);
     Number_FD++;
+    F->swap_dir = -1;
 }
 
 void
Index: squid/src/ftp.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/ftp.c,v
retrieving revision 1.5.10.1.4.1
retrieving revision 1.5.10.1.4.1.2.1
diff -u -r1.5.10.1.4.1 -r1.5.10.1.4.1.2.1
--- squid/src/ftp.c	17 Dec 2000 14:09:08 -0000	1.5.10.1.4.1
+++ squid/src/ftp.c	17 Dec 2000 14:36:24 -0000	1.5.10.1.4.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ftp.c,v 1.5.10.1.4.1 2000/12/17 14:09:08 hno Exp $
+ * $Id: ftp.c,v 1.5.10.1.4.1.2.1 2000/12/17 14:36:24 hno Exp $
  *
  * DEBUG: section 9     File Transfer Protocol (FTP)
  * AUTHOR: Harvest Derived
@@ -879,7 +879,7 @@
 #endif
     memset(ftpState->data.buf + ftpState->data.offset, '\0', read_sz);
     statCounter.syscalls.sock.reads++;
-    len = read(fd, ftpState->data.buf + ftpState->data.offset, read_sz);
+    len = comm_read_wrapper(fd, ftpState->data.buf + ftpState->data.offset, read_sz);
     if (len > 0) {
 	fd_bytes(fd, len, FD_READ);
 #if DELAY_POOLS
@@ -888,7 +888,6 @@
 	kb_incr(&statCounter.server.all.kbytes_in, len);
 	kb_incr(&statCounter.server.ftp.kbytes_in, len);
 	ftpState->data.offset += len;
-	CLEAR_CAN_READ_IF_EMPTY( read_sz, len, fd );
     }
     debug(9, 5) ("ftpDataRead: FD %d, Read %d bytes\n", fd, len);
     if (len > 0) {
@@ -903,7 +902,6 @@
     if (len < 0) {
 	debug(50, ignoreErrno(errno) ? 3 : 1) ("ftpDataRead: read error: %s\n", xstrerror());
 	if (ignoreErrno(errno)) {
-	    CLEAR_CAN_READ( fd );
 	    commSetSelect(fd,
 		COMM_SELECT_READ,
 		ftpDataRead,
@@ -1251,21 +1249,18 @@
     }
     assert(ftpState->ctrl.offset < ftpState->ctrl.size);
     statCounter.syscalls.sock.reads++;
-    len = read(fd,
+    len = comm_read_wrapper(fd,
 	ftpState->ctrl.buf + ftpState->ctrl.offset,
 	ftpState->ctrl.size - ftpState->ctrl.offset);
     if (len > 0) {
 	fd_bytes(fd, len, FD_READ);
 	kb_incr(&statCounter.server.all.kbytes_in, len);
 	kb_incr(&statCounter.server.ftp.kbytes_in, len);
-	CLEAR_CAN_READ_IF_EMPTY( ftpState->ctrl.size - ftpState->ctrl.offset,
-				 len, fd );
     }
     debug(9, 5) ("ftpReadControlReply: FD %d, Read %d bytes\n", fd, len);
     if (len < 0) {
 	debug(50, ignoreErrno(errno) ? 3 : 1) ("ftpReadControlReply: read error: %s\n", xstrerror());
 	if (ignoreErrno(errno)) {
-	    CLEAR_CAN_READ( fd );
 	    ftpScheduleReadControlReply(ftpState, 0);
 	} else {
 	    ftpFailed(ftpState, ERR_READ_ERROR);
Index: squid/src/gopher.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/gopher.c,v
retrieving revision 1.5.4.1.4.1
retrieving revision 1.5.4.1.4.1.2.1
diff -u -r1.5.4.1.4.1 -r1.5.4.1.4.1.2.1
--- squid/src/gopher.c	17 Dec 2000 14:09:08 -0000	1.5.4.1.4.1
+++ squid/src/gopher.c	17 Dec 2000 14:36:24 -0000	1.5.4.1.4.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: gopher.c,v 1.5.4.1.4.1 2000/12/17 14:09:08 hno Exp $
+ * $Id: gopher.c,v 1.5.4.1.4.1.2.1 2000/12/17 14:36:24 hno Exp $
  *
  * DEBUG: section 10    Gopher
  * AUTHOR: Harvest Derived
@@ -612,7 +612,7 @@
 #endif
     /* leave one space for \0 in gopherToHTML */
     statCounter.syscalls.sock.reads++;
-    len = read(fd, buf, read_sz);
+    len = comm_read_wrapper(fd, buf, read_sz);
     if (len > 0) {
 	fd_bytes(fd, len, FD_READ);
 #if DELAY_POOLS
@@ -620,7 +620,6 @@
 #endif
 	kb_incr(&statCounter.server.all.kbytes_in, len);
 	kb_incr(&statCounter.server.other.kbytes_in, len);
-	CLEAR_CAN_READ_IF_EMPTY( read_sz, len, fd );
 	commSetTimeout(fd, Config.Timeout.read, NULL, NULL);
 	IOStats.Gopher.reads++;
 	for (clen = len - 1, bin = 0; clen; bin++)
@@ -631,7 +630,6 @@
     if (len < 0) {
 	debug(50, 1) ("gopherReadReply: error reading: %s\n", xstrerror());
 	if (ignoreErrno(errno)) {
-	    CLEAR_CAN_READ( fd );
 	    commSetSelect(fd, COMM_SELECT_READ, gopherReadReply, data, 0);
 	} else if (entry->mem_obj->inmem_hi == 0) {
 	    ErrorState *err;
Index: squid/src/http.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/http.c,v
retrieving revision 1.5.10.1.4.1
retrieving revision 1.5.10.1.4.1.2.1
diff -u -r1.5.10.1.4.1 -r1.5.10.1.4.1.2.1
--- squid/src/http.c	17 Dec 2000 14:09:08 -0000	1.5.10.1.4.1
+++ squid/src/http.c	17 Dec 2000 14:36:24 -0000	1.5.10.1.4.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: http.c,v 1.5.10.1.4.1 2000/12/17 14:09:08 hno Exp $
+ * $Id: http.c,v 1.5.10.1.4.1.2.1 2000/12/17 14:36:24 hno Exp $
  *
  * DEBUG: section 11    Hypertext Transfer Protocol (HTTP)
  * AUTHOR: Harvest Derived
@@ -483,7 +483,7 @@
     read_sz = delayBytesWanted(delay_id, 1, read_sz);
 #endif
     statCounter.syscalls.sock.reads++;
-    len = read(fd, buf, read_sz);
+    len = comm_read_wrapper(fd, buf, read_sz);
     debug(11, 5) ("httpReadReply: FD %d: len %d.\n", fd, len);
     if (len > 0) {
 	fd_bytes(fd, len, FD_READ);
@@ -497,7 +497,6 @@
 	for (clen = len - 1, bin = 0; clen; bin++)
 	    clen >>= 1;
 	IOStats.Http.read_hist[bin]++;
-	CLEAR_CAN_READ_IF_EMPTY( read_sz, len, fd );
     }
     if (!httpState->reply_hdr && len > 0) {
 	/* Skip whitespace */
@@ -513,7 +512,6 @@
 	debug(50, 2) ("httpReadReply: FD %d: read failure: %s.\n",
 	    fd, xstrerror());
 	if (ignoreErrno(errno)) {
-	  CLEAR_CAN_READ( fd );
 	    commSetSelect(fd, COMM_SELECT_READ, httpReadReply, httpState, 0);
 	} else if (entry->mem_obj->inmem_hi == 0) {
 	    ErrorState *err;
Index: squid/src/main.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/main.c,v
retrieving revision 1.6.4.1.4.1
retrieving revision 1.6.4.1.4.1.2.1
diff -u -r1.6.4.1.4.1 -r1.6.4.1.4.1.2.1
--- squid/src/main.c	17 Dec 2000 14:09:08 -0000	1.6.4.1.4.1
+++ squid/src/main.c	17 Dec 2000 14:36:24 -0000	1.6.4.1.4.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: main.c,v 1.6.4.1.4.1 2000/12/17 14:09:08 hno Exp $
+ * $Id: main.c,v 1.6.4.1.4.1.2.1 2000/12/17 14:36:24 hno Exp $
  *
  * DEBUG: section 1     Startup and Main Loop
  * AUTHOR: Harvest Derived
@@ -493,6 +493,10 @@
     refererOpenLog();
     httpHeaderInitModule();	/* must go before any header processing (e.g. the one in errorInitialize) */
     httpReplyInitModule();	/* must go before accepting replies */
+#if defined( TCP_ASYNC )
+    /* must go before error text loading */
+    initCommCio();
+#endif
     errorInitialize();
     accessLogInit();
 #if USE_IDENT
@@ -563,10 +567,9 @@
 	eventAdd("fqdncache_purgelru", fqdncache_purgelru, NULL, 15.0, 1);
     }
 
-#if defined( TCP_ASYNC )
-    initCommCio();
+#if defined( DISK_REPL )
+    raidInitListener();
 #endif
-
     configured_once = 1;
 }
 
@@ -722,7 +725,7 @@
 	if ((loop_delay = eventNextTime()) < 0)
 	    loop_delay = 0;
 #if defined( TCP_ASYNC )
-	/* cannot remove poll/select loops at this time, bacause disk IO 
+	/* cannot remove poll/select loops at this time, because disk IO 
 	   doesn't use signals yet */
 	switch( commCioLoop() ) {
 	case COMM_OK:
@@ -751,10 +754,11 @@
 /* PROFILE_SQUID */
 #endif
 #if HAVE_POLL
-	switch (comm_poll(loop_delay)) {
+	switch (comm_poll(loop_delay))
 #else
-	switch (comm_select(loop_delay)) {
+	switch (comm_select(loop_delay))
 #endif
+	{
 	case COMM_OK:
 	    errcount = 0;	/* reset if successful */
 	    break;
Index: squid/src/protos.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/protos.h,v
retrieving revision 1.6.4.1.2.1.2.1
retrieving revision 1.6.4.1.2.1.2.1.2.1
diff -u -r1.6.4.1.2.1.2.1 -r1.6.4.1.2.1.2.1.2.1
--- squid/src/protos.h	17 Dec 2000 14:09:08 -0000	1.6.4.1.2.1.2.1
+++ squid/src/protos.h	17 Dec 2000 14:36:24 -0000	1.6.4.1.2.1.2.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: protos.h,v 1.6.4.1.2.1.2.1 2000/12/17 14:09:08 hno Exp $
+ * $Id: protos.h,v 1.6.4.1.2.1.2.1.2.1 2000/12/17 14:36:24 hno Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -149,6 +149,8 @@
     CWCB * handler,
     void *handler_data,
     FREE *);
+extern int comm_read_wrapper( int fd, char *buf, int size );
+extern int comm_write_wrapper( int fd, char *buf, int size );
 extern void comm_write_mbuf(int fd, MemBuf mb, CWCB * handler, void *handler_data);
 extern void commCallCloseHandlers(int fd);
 extern int commSetTimeout(int fd, int, PF *, void *);
@@ -156,6 +158,34 @@
 extern int ignoreErrno(int);
 extern void commCloseAllSockets(void);
 
+extern int addSyscallCB( SyscallCBInvoc *hook, SyscallCallBack cb, void *data );
+extern int delSyscallCB( SyscallCBInvoc *hook, SyscallCallBack cb );
+extern int addReadHook( SyscallCallBack cb, void *data );
+extern int addWriteHook( SyscallCallBack cb, void *data );
+extern syscallcb_result callSyscallCBHook( SyscallCBInvoc *hook, 
+										   syscall_type call,
+										   int fd, int *errNo );
+extern syscallcb_result callReadHook( int fd, int *errNo );
+extern syscallcb_result callWriteHook( int fd, int *errNo );
+extern syscallcb_result echoSyscallCB( syscall_type call,
+									   int fd, int *errNo,
+									   void *data );
+
+/* raid.c */
+#if defined( DISK_REPL )
+extern syscallcb_result watchDiskDies( syscall_type call,
+									   int fd, int *errNo,
+									   void *data );
+extern int offlineSwapDir( int index );
+extern int onlineSwapDir( int index );
+syscallcb_result simulateCrash( syscall_type call, 
+								int fd, int *errNo, void *data );
+int findFirstOnlineSD();
+int raidInit();
+void raidInitListener();
+/* DISK_REPL */
+#endif
+
 
 /*
  * comm_select.c
@@ -1229,6 +1259,8 @@
 extern int commCioLoop();
 extern int cioCatchLostIO();
 extern int initCommCio();
+extern void clearLostIOBitmap( int fd );
+extern void setLostIOBitmap( int fd );
 #endif
 extern int checkAsyncFlag( int fd );
 /*
Index: squid/src/pump.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/Attic/pump.c,v
retrieving revision 1.4.14.1.4.1
retrieving revision 1.4.14.1.4.1.2.1
diff -u -r1.4.14.1.4.1 -r1.4.14.1.4.1.2.1
--- squid/src/pump.c	17 Dec 2000 14:09:08 -0000	1.4.14.1.4.1
+++ squid/src/pump.c	17 Dec 2000 14:36:24 -0000	1.4.14.1.4.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: pump.c,v 1.4.14.1.4.1 2000/12/17 14:09:08 hno Exp $
+ * $Id: pump.c,v 1.4.14.1.4.1.2.1 2000/12/17 14:36:24 hno Exp $
  *
  * DEBUG: section 61    PUMP handler
  * AUTHOR: Kostas Anagnostakis
@@ -230,17 +230,15 @@
     int len = 0;
     errno = 0;
     statCounter.syscalls.sock.reads++;
-    len = read(fd, buf, bytes_to_read);
+    len = comm_read_wrapper(fd, buf, bytes_to_read);
     fd_bytes(fd, len, FD_READ);
     debug(61, 5) ("pumpReadFromClient: FD %d: len %d.\n", fd, len);
     if (len > 0) {
 	(void) 0;		/* continue */
-	CLEAR_CAN_READ_IF_EMPTY( bytes_to_read, len, fd );
     } else if (len < 0) {
 	debug(61, 2) ("pumpReadFromClient: FD %d: read failure: %s.\n",
 	    fd, xstrerror());
 	if (ignoreErrno(errno)) {
-	  CLEAR_CAN_READ( fd );
 	    debug(61, 5) ("pumpReadFromClient: FD %d: len %d and ignore!\n",
 		fd, len);
 	    commSetSelect(fd,
